
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include <sys/time.h>

void readConeValues();
int checkConeValues();
extern ObjectStruct ObjectValues;

#define ASCIITEXTATTRIBUTES \
    XtNeditType, XawtextEdit, \
    XtNtype, XawAsciiString, \
    XtNuseStringInPlace, True, \
    XtNresizable, True, \
    XtNresize, XawtextResizeWidth, \
    XtNright, XtChainRight,


typedef struct _Text {
    char *filetext;
    char *textP1, *textP2;
    char *textR1, *textR2;
    char *text1, *text2, *text3,
    *text4, *text5, *text6;
} 
Text, *TextPtr;


typedef struct _Widg {
    Widget cl, tp, bt;
} 
Widg, *WidgPtr;


typedef struct _Pass {
    TextPtr text;
    WidgPtr widg;
} 
Pass, *PassPtr;


/*
 *   Function Name: getOFFValues
 *   Description: Creates and pops up the Dialog widget to ask for a new
 *                input values
 *   Arguments: w - the command button that activated this function.
 *   Returns: none.
 */

void
generateCone( toplevel )
Widget toplevel;
{
    TextPtr   text = (TextPtr) malloc( sizeof (Text) );
    WidgPtr   widg = (WidgPtr) malloc( sizeof (Widg) );
    PassPtr   pass = (PassPtr) malloc( sizeof (Pass) );

    Widget    g_popup, g_form;
    Widget    g_label0, g_filelabel, g_filetext;
    Widget    g_label1,
              g_label7, g_label8, g_label9;
    Widget    g_text1, g_text2, g_text3, g_text4, g_text5, g_text6,
              g_toggle7, g_toggle8, g_toggle9;
    Widget    g_label000, g_label001, g_label002;
    Widget    g_labelP1, g_labelP2, g_textP1, g_textP2;
    Widget    g_labelR1, g_labelR2, g_textR1, g_textR2;
    Widget    g_labelx, g_labely, g_labelz;
    Widget    g_ok, g_cancel;
    Widget    g_title1, g_title2;

    Position x, y;

    char   string[20];
    String buffer;

    struct timeval tp;
    struct timezone tzp;

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    ObjectValues.Obj.Cone.point1.x = 0.0;
    ObjectValues.Obj.Cone.point1.y = 0.0;
    ObjectValues.Obj.Cone.point1.z = 0.0;
    ObjectValues.Obj.Cone.radius1 = 1.;
    ObjectValues.Obj.Cone.point2.x = 0.0;
    ObjectValues.Obj.Cone.point2.y = 1.0;
    ObjectValues.Obj.Cone.point2.z = 0.0;
    ObjectValues.Obj.Cone.radius2 = 0.5;
    ObjectValues.Obj.Cone.depth = 3;
    ObjectValues.Obj.Cone.clockwise = False;
    ObjectValues.Obj.Cone.top = False;
    ObjectValues.Obj.Cone.bottom = False;

    map_dialog(toplevel, &x, &y);
    g_popup = XtVaCreatePopupShell( "Get Values",
        transientShellWidgetClass, toplevel,
        XtNx, x, XtNy, y,
        NULL );

    g_form = XtVaCreateManagedWidget( "g_form", formWidgetClass, g_popup,
        NULL );

    sprintf( string, "Object : Cone" );
    g_label0 = XtVaCreateManagedWidget( "g_label0", labelWidgetClass, g_form,
        XtNlabel, string,
        NULL );

    gettimeofday( &tp, &tzp );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "cone_%d.geom", (tp.tv_sec)%1000 );
    text->filetext = XtNewString( buffer );
    g_filelabel = XtVaCreateManagedWidget( "g_filelabel", labelWidgetClass,
        g_form,
        XtNfromVert, g_label0,
        NULL );
    g_filetext = XtVaCreateManagedWidget( "g_filetext", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->filetext,
        XtNlength, 30,
        XtNwidth, 11*strlen(buffer),
        XtNinsertPosition, strlen(buffer),
        XtNfromVert, g_label0,
        XtNfromHoriz, g_filelabel,
        NULL );

    g_label000 = XtVaCreateManagedWidget( "g_label000", labelWidgetClass,g_form,
        XtNfromVert, g_filelabel,
        NULL );

    g_title1 = XtVaCreateManagedWidget( "g_title1", labelWidgetClass, g_form,
        XtNfromVert, g_label000,
        NULL );

    g_labelP1 = XtVaCreateManagedWidget( "g_labelP1", labelWidgetClass, g_form,
        XtNwidth, 10*11,
        XtNfromVert, g_title1,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Cone.point1.x,
        ObjectValues.Obj.Cone.point1.y, ObjectValues.Obj.Cone.point1.z );
    text->textP1 = XtNewString( buffer );
    g_textP1 = XtVaCreateManagedWidget( "g_textP1", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textP1,
        XtNlength, 25,
        XtNwidth, 11*strlen(text->textP1),
        XtNinsertPosition, strlen(text->textP1),
        XtNfromVert, g_title1,
        XtNfromHoriz, g_labelP1,
        NULL );

    g_labelR1 = XtVaCreateManagedWidget( "g_labelR1", labelWidgetClass, g_form,
        XtNwidth, 10*11,
        XtNfromVert, g_labelP1,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Cone.radius1 );
    text->textR1 = XtNewString( buffer );
    g_textR1  = XtVaCreateManagedWidget( "g_textR1", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textR1,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->textR1),
        XtNfromVert, g_labelP1,
        XtNfromHoriz, g_labelR1,
        NULL );

    g_labelP2 = XtVaCreateManagedWidget( "g_labelP2", labelWidgetClass, g_form,
        XtNwidth, 10*11,
        XtNfromVert, g_labelR1,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Cone.point2.x,
        ObjectValues.Obj.Cone.point2.y, ObjectValues.Obj.Cone.point2.z );
    text->textP2 = XtNewString( buffer );
    g_textP2 = XtVaCreateManagedWidget( "g_textP2", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textP2,
        XtNlength, 25,
        XtNwidth, 11*strlen(text->textP2),
        XtNinsertPosition, strlen(text->textP2),
        XtNfromVert, g_labelR1,
        XtNfromHoriz, g_labelP2,
        NULL );

    g_labelR2 = XtVaCreateManagedWidget( "g_labelR2", labelWidgetClass, g_form,
        XtNwidth, 10*11,
        XtNfromVert, g_labelP2,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Cone.radius2 );
    text->textR2 = XtNewString( buffer );
    g_textR2  = XtVaCreateManagedWidget( "g_textR2", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textR2,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->textR2),
        XtNfromVert, g_labelP2,
        XtNfromHoriz, g_labelR2,
        NULL );

    g_label1 = XtVaCreateManagedWidget( "g_label1", labelWidgetClass, g_form,
        XtNwidth, 10*11,
        XtNfromVert, g_labelR2,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues.Obj.Cone.depth );
    text->text1 = XtNewString( buffer );
    g_text1  = XtVaCreateManagedWidget( "g_text1", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text1,
        XtNlength, 1,
        XtNinsertPosition, strlen(text->text1),
        XtNfromVert, g_labelR2,
        XtNfromHoriz, g_label1,
        NULL );

    g_label001 = XtVaCreateManagedWidget( "g_label001", labelWidgetClass,g_form,
        XtNfromVert, g_label1,
        NULL );

    g_title2 = XtVaCreateManagedWidget( "g_title2", labelWidgetClass, g_form,
        XtNfromVert, g_label001,
        NULL );
    g_label7 = XtVaCreateManagedWidget( "g_label7", labelWidgetClass, g_form,
        XtNfromVert, g_title2,
        NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle7  = XtVaCreateManagedWidget( "g_toggle7", toggleWidgetClass,g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_title2,
        XtNfromHoriz, g_label7,
        NULL );
    if( ObjectValues.Obj.Cone.clockwise )
        XtVaSetValues( g_toggle7, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle7, XtNlabel, "-", NULL );

    g_label8 = XtVaCreateManagedWidget( "g_label8", labelWidgetClass, g_form,
        XtNfromVert, g_label7,
        NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle8  = XtVaCreateManagedWidget( "g_toggle8", toggleWidgetClass,g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label7,
        XtNfromHoriz, g_label8,
        NULL );
    if( ObjectValues.Obj.Cone.top )
        XtVaSetValues( g_toggle8, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle8, XtNlabel, "-", NULL );

    g_label9 = XtVaCreateManagedWidget( "g_label9", labelWidgetClass, g_form,
        XtNfromVert, g_label8,
        NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle9  = XtVaCreateManagedWidget( "g_toggle9", toggleWidgetClass,g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label8,
        XtNfromHoriz, g_label9,
        NULL );
    if( ObjectValues.Obj.Cone.bottom )
        XtVaSetValues( g_toggle9, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle9, XtNlabel, "-", NULL );

    g_label002 = XtVaCreateManagedWidget( "g_label002", labelWidgetClass,g_form,
        XtNfromVert, g_label9,
        NULL );

    widg->cl = g_toggle7;
    widg->tp = g_toggle8;
    widg->bt = g_toggle9;
    pass->text = text;
    pass->widg = widg;

    callbacks[0].callback = (XtCallbackProc) readConeValues;
    callbacks[0].closure  = (XtPointer) pass;
    g_ok = XtVaCreateManagedWidget( "g_ok", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        NULL );

    callbacks[0].callback = (XtCallbackProc) DestroyPopupPrompt;
    callbacks[0].closure  = (XtPointer) g_popup;
    g_cancel = XtVaCreateManagedWidget( "g_cancel", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        XtNfromHoriz, g_ok,
        NULL );

/*
    XtRealizeWidget( g_popup );
*/
    XtPopup( g_popup, XtGrabNone );
    XMapRaised( XtDisplay( g_popup ), XtWindow( XtParent( g_popup ) ) );
}


static void
changeSign( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Boolean state;

    XtVaGetValues( widget, XtNstate, &state, NULL );
    if( state ) XtVaSetValues( widget, XtNlabel, "+", NULL );
    if( !state ) XtVaSetValues( widget, XtNlabel, "-", NULL );
}


static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Widget popup = (Widget)client_data;
    extern char creatingObject;
    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


void
readConeValues( widget, client_data, call_data )
Widget widget;
XtPointer client_data, call_data;
{
    Widget popup = XtParent( XtParent( widget ) );
    PassPtr pass = (PassPtr) client_data;
    WidgPtr pwidg = (WidgPtr) pass->widg;
    TextPtr ptext = (TextPtr) pass->text;
    extern char creatingObject;

    Point point1, point2;
    float radius1, radius2;
    int depth;
    Boolean clockwise, top, bottom;
    Status status;
    int primitive=0;

    extern String filename;

    filename = (String) malloc( strlen((const char *)getenv("OBJ_PATH")) + 80 );

    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), ptext->filetext );
    sscanf( ptext->textP1, "%f %f %f", &(point1.x), &(point1.y), &(point1.z) );
    XtFree( ptext->textP1 );
    sscanf( ptext->textR1, "%f", &radius1 );
    XtFree( ptext->textR1 );
    sscanf( ptext->textP2, "%f %f %f", &(point2.x), &(point2.y), &(point2.z) );
    XtFree( ptext->textP2 );
    sscanf( ptext->textR2, "%f", &radius2 );
    XtFree( ptext->textR2 );
    sscanf( ptext->text1, "%d", &depth );
    XtFree( ptext->text1 );

    XtVaGetValues( pwidg->cl, XtNstate, &clockwise, NULL );
    XtVaGetValues( pwidg->tp, XtNstate, &top, NULL );
    XtVaGetValues( pwidg->bt, XtNstate, &bottom, NULL );

    ObjectValues.Obj.Cone.point1.x = point1.x;
    ObjectValues.Obj.Cone.point1.y = point1.y;
    ObjectValues.Obj.Cone.point1.z = point1.z;
    ObjectValues.Obj.Cone.radius1 = radius1;
    ObjectValues.Obj.Cone.point2.x = point2.x;
    ObjectValues.Obj.Cone.point2.y = point2.y;
    ObjectValues.Obj.Cone.point2.z = point2.z;
    ObjectValues.Obj.Cone.radius2 = radius2;
    ObjectValues.Obj.Cone.depth = depth;
    ObjectValues.Obj.Cone.clockwise = clockwise;
    ObjectValues.Obj.Cone.top = top;
    ObjectValues.Obj.Cone.bottom = bottom;

    if( !(status = checkConeValues( popup, radius1, radius2, depth ) ) )
        Cone( point1, radius1, point2, radius2, depth,
              clockwise, top, bottom, primitive );

    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


int
checkConeValues( w, radius1, radius2, depth )
Widget w;
float radius1, radius2;
int depth;
{
    char buffer[80];
    int errors = 0;

    if( depth < 1 || depth > 7 ) {
        sprintf( buffer, "Error -- Required Condition: 1 <= depth(%d) <= 7\n",
            depth );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( radius1 ) && NEAR_ZERO( radius2 ) ) {
        sprintf( buffer,
            "Error -- Required Condition: radius1(%.2f) != radius2 != 0.0\n",
            radius1 );
        message( w, buffer );
        errors++;
    }
    return errors;
}
