
#include "unix.h"
#include "x.h"
#include "xt.h"

XtCallbackProc DestroyPopupPrompt();
static char Done;

void message( button, note )
Widget button;
char *note;
{
    Widget    m_title, m_popup, m_form, m_label, quit;
    Position  x, y;
    Dimension width, height, border_width;
    int px, py,  dummy;
    unsigned int mask;
    Window root, child;
    extern XtAppContext app_context;

    /*
     * This will position the upper left hand corner of the popup at the
     * center of the widget which invoked this callback, which will also
     * become the parent of the popup.  I don't deal with the possibility
     * that the popup will be all or partially off the edge of the screen.
     */

    XtRealizeWidget( button );
    XQueryPointer( XtDisplay(button), XtWindow(button), &root, &child,
                   &px, &py, &dummy, &dummy, &mask );
    XtVaGetValues( button,
                   XtNwidth, &width,
                   XtNheight, &height,
                   XtNborderWidth, &border_width,
                   NULL );
    width  += border_width + border_width;
    height += border_width + border_width;
    x = px + (width / 2);
    y = py + (height / 2);
    x = px+5;
    y = py;
    if ((int)(x + width) > WidthOfScreen( XtScreen(button) ))
      x = WidthOfScreen( XtScreen(button) ) - width;
    if ((int)(y + height) > HeightOfScreen( XtScreen(button) ))
      y = HeightOfScreen( XtScreen(button) ) - height;
    if (x < 0) x = 0;
    if (y < 0) y = 0;

    m_popup = XtVaCreatePopupShell( "Error", topLevelShellWidgetClass, button,
                                   XtNx, x, XtNy, y,
                                   NULL );

    m_form = XtVaCreateManagedWidget( "m_form", formWidgetClass, m_popup,
                                     XtNx, x, XtNy, y,
                                     NULL );

    m_label = XtVaCreateManagedWidget( "m_label", labelWidgetClass, m_form,
                                      XtNlabel, "Fatal Error :",
                                      XtNborderWidth, 0,
                                      NULL );

    m_title = XtVaCreateManagedWidget( "m_title", labelWidgetClass, m_form,
                                      XtNlabel, note,
                                      XtNfromVert, m_label,
                                      NULL );

    quit = XtVaCreateManagedWidget( "quit", commandWidgetClass, m_form,
                                     XtNfromVert, m_title, NULL );

    XtAddCallback( quit, XtNcallback, (XtCallbackProc)DestroyPopupPrompt, (XtPointer)m_form );
    XtManageChild( m_popup );
    XtPopup( XtParent( m_popup ), XtGrabExclusive );
/*
    if( XGrabKeyboard( XtDisplay( m_popup ), XtWindow( m_popup ), True,
                       GrabModeAsync, GrabModeAsync, NULL) )
    {
        printf("message: could not grab keyboard. \n");
        exit(1);
    }

    if( XGrabPointer( XtDisplay( m_popup ), XtWindow( m_popup ), True,
                      ButtonPressMask, GrabModeAsync, GrabModeAsync,
                      XtWindow( m_popup ), NULL, NULL ) )
    {
        printf("message: could not grab pointer. \n");
        exit(1);
    }
*/
    Done = False;
    while( !Done ) {
        XEvent event;

        XtAppNextEvent( app_context, &event );
        XtDispatchEvent( &event );
    }

    XtPopdown( m_popup );
    XtUnmapWidget( m_popup );       /* instead of XtDestroyWidget( m_popup ); */
}


/*
 *   Function Name: DestroyPopupPrompt
 *   Returns: none.
 */

XtCallbackProc
DestroyPopupPrompt( w, client_data, call_data )
Widget    w;
XtPointer client_data, call_data;
{
    Done = True;
}
