
#include "unix.h"

typedef struct _Point {
    float x, y, z;
} Point;


Torus( xaxis, yaxis, zaxis, radius, center, n1, n2, depth, clockwise )
float xaxis, yaxis, zaxis, radius;
Point center;
int n1, n2;
int depth;
char clockwise;
{
    int i, j;        /* i/phi    j/theta */
    float is, js;
    float phi, theta, step;
    float fphiSize, fthetaSize;
    int phiSize, thetaSize;
    Point torus[130][260];
    FILE *fp;
    extern char *filename;

    fp = fopen( filename, "w" );

    step = (float)(M_PI / pow( (double)2, (double)depth ));
    fphiSize = (2 * M_PI / step) + 1.;
    fthetaSize = (2 * M_PI / step) + 1.;
    phiSize = (int)fphiSize;
    thetaSize = (int)fthetaSize;

    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
           is = -M_PI + i * step;
           js = -M_PI + j * step;
           torus[i][j].x = xaxis * (radius + pow( cos( is ), (double)n1 ) )
                                 * pow( cos( js ), (double)n2 ) + center.x;
           torus[i][j].y = yaxis * (radius + pow( cos( is ), (double)n1 ) )
                                 * pow( sin( js ), (double)n2 ) + center.y;
           torus[i][j].z = zaxis *           pow( sin( is ), (double)n1 )
                                                                + center.z;
        }
    }

    fprintf( fp, "%d\t%d\t%d\n", phiSize * thetaSize,
                 (phiSize-1) * (thetaSize-1), 4 * (phiSize-1) * (thetaSize-1) );

    /* Print the Coordinates of the points */
    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            fprintf( fp, "%f %f %f\n", torus[i][j].x, torus[i][j].y,
                                       torus[i][j].z );
        }
    }

    /* Print the Conectivity data of the points */
    if( !clockwise ) {    /* counterClockwise */
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1,         j*thetaSize+(i+1)+1,
                       (j+1)*thetaSize+(i+1)+1, (j+1)*thetaSize+i+1 );
            }
        }
    }
    else {
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1, (j+1)*thetaSize+i+1,
                   (j+1)*thetaSize+(i+1)+1, j*thetaSize+(i+1)+1 );
            }
        }
    }
    fclose( fp );
}
